package wff.game.frame;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics ; 
import java.awt.Toolkit ;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class FiveChessFrame extends JFrame implements MouseListener,Runnable
{
	//ȡĻĿ
	int widthScreen = Toolkit.getDefaultToolkit().getScreenSize().width ;
	//ȡĻĸ߶
	int heightScreen = Toolkit.getDefaultToolkit().getScreenSize().height ;
	//׼ͼƬ
	BufferedImage bfImage = null ;
	//ӵ
	private int x = 0 ;
	private int y = 0 ;
	/**
	 * 
	 * ֵΪ0ʾû
	 * ֵΪ1,ʾǺ
	 * ֵΪ2,ʾǰ
	 */
	private int[][] allChess = new int[19][19] ;
	//жӵɫ
	private boolean isColor = true ;
	//ʶǷ񻹿
	private boolean canPlay = true ;
	//ϷʾϢ
	private String message = "ڷ" ;
	//߳
	private boolean threadFlag = false ;
	//ܵʱ
	private int fullTime = 0 ;
	private int tempTime1 = 0 ;
	private int tempTime2 = 0 ;
	//ʾϰ׷ڷĵʱ
	private String whiteTime = "" ;
	private String blackTime = "" ;
	
	public FiveChessFrame()
	{
		this.setTitle("Ϸ") ;
		this.setSize(500,500) ;
		this.setLocation((widthScreen-500)/2,(heightScreen-500)/2) ;
		this.setResizable(false) ;
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE) ;
		this.setVisible(true) ;
		
		//ʵͼƬ
		try {
			bfImage = ImageIO.read(new File("picture\\chess.jpg")) ;
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		this.repaint() ;		//paint
		//ʱ߳
		new Thread(this).start() ;
		//Ϊ
		this.addMouseListener(this) ;
	}
	
	//
	public void paint(Graphics g)
	{
		//˫弼ֹĻ˸
		BufferedImage bufImage = new BufferedImage(500,500,BufferedImage.TYPE_INT_RGB) ;
		Graphics g2 = bufImage.createGraphics() ;
		
		g2.setColor(Color.BLACK) ;
		g2.drawImage(bfImage, 0, 20,this) ;	//Ʊ
		//̷
		for(int i=0; i<19;i++)
		{
			g2.drawLine(13, 73 + 20*i, 374, 73 + 20*i) ;	//̺
			g2.drawLine(13 + 20*i,72,13 + 20*i,432) ;	//
		}
		//ϵĵ
		g2.fillOval(71, 131, 4, 4) ;
		g2.fillOval(311, 131, 4, 4) ;
		g2.fillOval(71, 371, 4, 4) ;
		g2.fillOval(311, 371, 4, 4) ;
		
		g2.fillOval(71, 251, 4, 4) ;
		g2.fillOval(311, 251, 4, 4) ;
		g2.fillOval(191, 131, 4, 4) ;
		g2.fillOval(191, 371, 4, 4) ;
		g2.fillOval(191, 251, 4, 4) ;
		//
		g2.setFont(new Font("",Font.PLAIN,20)) ;
		g2.drawString("ʾϢ" + message, 140, 65) ;
		g2.setFont(new Font("",Font.PLAIN,12)) ;
		g2.drawString("ڷʱ䣺" + blackTime, 40, 475) ;
		g2.drawString("׷ʱ䣺" + whiteTime, 210, 475) ;
		
		//
		/**
		 * ʵڲҶάеֵ
		 * 
		 * ά±෴Ӧ
		 */
		for(int i=0; i<19; i++)
		{
			for(int j=0; j<19; j++)
			{
				if(allChess[i][j]==1)	//ƺ
				{
					g2.setColor(Color.WHITE) ;
					g2.drawOval(i*20+6, j*20+65, 14, 14) ;
					g2.setColor(Color.BLACK) ;
					g2.fillOval(i*20+6, j*20+65, 14, 14) ;
				}
				if(allChess[i][j]==2)	//ư
				{
					g2.setColor(Color.WHITE) ;
					g2.fillOval(i*20+6, j*20+65, 14, 14) ;
					g2.setColor(Color.BLACK) ;
					g2.drawOval(i*20+6, j*20+65, 14, 14) ;
				}
			}
		}
		g.drawImage(bufImage,0,0,this) ;
	}
	
	public void mouseClicked(MouseEvent e) 
	{
		x = e.getX() ;
		y = e.getY() ;
		if(canPlay)
		{
			if(x>=11 && x<= 376 && y>=70 && y<=435)	//жǷ
			{
				x = (x-13)/20 ;
				y = (y-72)/20 ;
				if(allChess[x][y] == 0)
				{
					if(isColor)
					{
						allChess[x][y] = 1 ;	//
						isColor = false ;
						message = "׷" ;
					}
					else
					{
						allChess[x][y] = 2 ;	//
						isColor = true ;
						message = "ڷ" ;
					}
					repaint() ;
					boolean winFlag = isWind() ;
					if(winFlag)
					{
						JOptionPane.showMessageDialog(this,
								(allChess[x][y]==1?"ڷ":"׷") + "ʤ" +
								(allChess[x][y]==1?"ڷ":"׷") + 
								"ո߲ɵϷ") ;
						canPlay = false ;
					}
				}
				else
				{
					JOptionPane.showMessageDialog(this, "˴ӣ") ;
				}
			}
		}
		//жϵʼϷť
		if(x>=415 && x<=465 && y>=78 && y<=95)
		{
			int result = JOptionPane.showConfirmDialog(this, "Ƿ¿ʼϷ") ;
			if(result==0)
			{
				for(int i=0; i<19; i++)
				{
					for(int j=0; j<19; j++)
					{
						allChess[i][j] = 0 ;
					}
				}
				//ı
				isColor = true ;		//ʾɫ
				//ıʾϢ
				message = "ڷ" ;
				canPlay = true ;		//Ϊֹǵ䰴ť׼
				//ıʾʱǩ
				blackTime = "" ;
				whiteTime = "" ;
				this.repaint() ;
			}
		}
		//жϵϷðť
		if(x>=415 && x<=465 && y>=112 && y<=125)
		{
			String result = JOptionPane.showInputDialog(this,"ʱ䣨λӣ") ;
			try	{
				fullTime = Integer.parseInt(result) * 60;
				int result1 = JOptionPane.showConfirmDialog(this, "ȷ¿ʼϷ") ;
				if(result1 == 0)
				{
					for(int i=0; i<19; i++)
					{
						for(int j=0; j<19; j++)
						{
							allChess[i][j] = 0 ;
						}
					}
					//ı
					isColor = true ;		//ʾɫ
					//ıʾϢ
					message = "ڷ" ;
					canPlay = true ;		//Ϊֹǵ䰴ť׼
					blackTime = fullTime/3600 + "" + fullTime%3600/60 + "" + fullTime%60 ;
					whiteTime = fullTime/3600 + "" + fullTime%3600/60 + "" + fullTime%60 ;
					tempTime1 = fullTime ;
					tempTime2 = fullTime ;
					threadFlag = true ;
					this.repaint() ;
				}
			}catch(Exception e1)
			{
				JOptionPane.showMessageDialog(this, "ȷʽʱ䣡") ;
			}
		}
		//жϵϷ˵ť
		if(x>=415 && x<=465 && y>=140 && y<=153)
		{
			JOptionPane.showMessageDialog(this,"Ϸ˵Ϸɣ˵˰ɣf") ;
		}
		//жϵ䰴ť
		if(x>=415 && x<=465 && y>=178 && y<=194)
		{
			int result = JOptionPane.showConfirmDialog(this, "ȷ") ;
			if(result == 0)
			{
				if(isColor)
				{
					JOptionPane.showMessageDialog(this, "׷ʤڷ䣡") ;
					canPlay = false ;	//ҪڿʼϷʱҪ¿ʼťñcanPlay
				}
				else
				{
					JOptionPane.showMessageDialog(this, "ڷʤ׷䣡") ;
					canPlay = false ;
				}
			}
		}
		//жϵڰť
		if(x>=415 && x<=465 && y>=209 && y<=224)
		{
			JOptionPane.showMessageDialog(this,"Ϸߣ꣡Ϸߣ壡") ;
		}
		//жϵϷðť
		if(x>=415 && x<=465 && y>=243 && y<=258)
		{
			JOptionPane.showMessageDialog(this,"	") ;
			System.exit(1) ;
		}
	}

	public void mouseEntered(MouseEvent arg0) 
	{
		
	}

	public void mouseExited(MouseEvent arg0)
	{
		
	}

	public void mousePressed(MouseEvent e) 
	{
		//System.out.println(e.getX() + "-----" + e.getY() ) ;
	}

	public void mouseReleased(MouseEvent arg0) 
	{
		
	}
	
	public boolean isWind()
	{
		boolean flag = false ;
		int color = allChess[x][y] ;	//жϵǰӵɫ
		int count = 1 ;		//ͳƵǰӵĸ
		
		// * жϺǷΪ
		// * λÿʼ
		int i = 1 ;
		while(x+i<=18 && color == allChess[x+i][y])	//ж
		{
			i++ ;
			count++ ;
		}
		i = 1 ;
		while(x-i>=0 && y<=18 && color == allChess[x-i][y])	//ж
		{
			i++ ;
			count++ ;
		}
		if(count>=5)
		{
			flag = true ;
		}
		 //* жǷΪ
		 //* λÿʼ
		count = 1 ;
		i = 1 ;
		while(y+i<=18 && color == allChess[x][y+i])	//ж
		{
			i++ ;
			count++ ;
		}
		i = 1 ;
		while(y-i>=0 && color == allChess[x][y-i])	//ж
		{
			i++ ;
			count++ ;
		}
		if(count>=5)
		{
			flag = true ;
		}
		
		// * бжǷΪ
		// * λÿʼ
		count = 1 ;
		i = 1 ;
		
		while(x+i<=18 && y-i>=0 && color == allChess[x+i][y-i])	//ж
		{
			i++ ;
			count++ ;
		}
		i = 1 ;
		
		while(x-i>=0 && y+i<=18 && color == allChess[x-i][y+i])	//ж
		{
			i++ ;
			count++ ;	
		}
		if(count>=5)
		{
			flag = true ;
		}
		// * бжǷΪ
		// * λÿʼ
		count = 1 ;
		i = 1 ;
		while(x+i>=18 && y+i>=18 && color == allChess[x+i][y+i])	//ж
		{
			i++ ;
			count++ ;
		}
		i = 1 ;
		while(y-i<=0&& x-i<=0 && color == allChess[x-i][y-i])	//ж
		{
			i++ ;
			count++ ;
		}
		if(count>=5)
		{
			flag = true ;
		}
		
		/*count = this.checkCount(1, 0, color) ;
		if(count>=5)
		{
			flag = true ;
		}
		else
		{
			count = this.checkCount(0, 1, color) ;
			if(count>=5)
			{
				flag = true ;
			}
			else
			{
				count = this.checkCount(1, -1, color) ;
				if(count>=5)
				{
					flag = true ;
				}
				else
				{
					count = this.checkCount(1, 1, color) ;
					if(count>=5)
					{
						flag = true ;
					}
				}
			}
		}*/
		return flag ;
	}
	/*
	public int checkCount(int chessX,int chessY,int color)
	{
		int count = 1 ;
		int tempX = chessX ;
		int tempY = chessY ;
		while(color == allChess[x + chessX][y + chessY])	//ж
		{
			if(chessX != 0)
			{
				chessX++ ;
			}
			if(chessY != 0)
			{
				if(chessY>0)
				{
					chessY++ ;
				}
				if(chessY<0)
				{
					chessY-- ;
				}
			}
			count++ ;
		}
		chessX = tempX ;
		chessY = tempY ;
		while(color == allChess[x - chessX][y - chessY])	//ж
		{
			if(chessX != 0)
			{
				chessX-- ;
			}
			if(chessY != 0)
			{
				if(chessY>0)
				{
					chessY++ ;
				}
				if(chessY<0)
				{
					chessY-- ;
				}
			}
			count++ ;
		}
		return count ;
	}*/
	public void run()
	{
		boolean flag = true ;
		while(flag)
		{
			if(threadFlag)
			{
				if(isColor)
				{
					tempTime1-- ;
					blackTime = tempTime1/3600 + "" + tempTime1%3600/60 + "" + tempTime1%60 ;
					if(tempTime1 == 0)
					{
						JOptionPane.showMessageDialog(this, "ڷʱ׷ʤ") ;
						flag = false ;
						canPlay = false ;
					}
					try {
						Thread.sleep(1000) ;
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				else
				{
					tempTime2-- ;
					whiteTime = tempTime2/3600 + "" + tempTime2%3600/60 + "" + tempTime2%60 ;
					if(tempTime2 == 0)
					{
						JOptionPane.showMessageDialog(this, "׷ʱڷʤ") ;
						flag = false ;
						canPlay = false ;
					}
					try {
						Thread.sleep(1000) ;
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				this.repaint() ;
			}
		}
	}
}
